
<!-- TITLE/ -->

# [Benjamin Lupton's](http://balupton.com) Utility Functions

<!-- /TITLE -->


<!-- BADGES/ -->

[![Build Status](http://img.shields.io/travis-ci/balupton/bal-util.png?branch=master)](http://travis-ci.org/balupton/bal-util "Check this project's build status on TravisCI")
[![NPM version](http://badge.fury.io/js/bal-util.png)](https://npmjs.org/package/bal-util "View this project on NPM")
[![Gittip donate button](http://img.shields.io/gittip/balupton.png)](https://www.gittip.com/balupton/ "Donate weekly to this project using Gittip")
[![Flattr donate button](http://img.shields.io/flattr/donate.png?color=yellow)](http://flattr.com/thing/344188/balupton-on-Flattr "Donate monthly to this project using Flattr")
[![PayPayl donate button](http://img.shields.io/paypal/donate.png?color=yellow)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=QB8GQPZAH84N6 "Donate once-off to this project using Paypal")

<!-- /BADGES -->


<!-- DESCRIPTION/ -->

Common utility functions for Node.js used and maintained by Benjamin Lupton

<!-- /DESCRIPTION -->


<!-- INSTALL/ -->

## Install

### [Node](http://nodejs.org/), [Browserify](http://browserify.org/)
- Use: `require('bal-util')`
- Install: `npm install --save bal-util`

### [Ender](http://ender.jit.su/)
- Use: `require('bal-util')`
- Install: `ender add bal-util`

<!-- /INSTALL -->


## Usage
Best off looking at source, it's well documented, and there are plenty of tests



## Future
We're in the process of abstracting the pieces of bal-util out into their own modules. So far, we've done the following:

- [ambi](https://github.com/bevry/ambi) < `balUtilFlow.fireWithOptionalCallback`
- [eachr](https://github.com/bevry/eachr) < `balUtilFlow.each`
- [event-emitter-grouped](https://github.com/bevry/event-emitter-grouped) < `balUtilEvents.EventEmitterEnhanced`
- [extendr](https://github.com/bevry/extendr) < `balUtilFlow.(extend|clone|etc)`
- [extract-opts](https://github.com/bevry/extract-opts) < `balUtilFlow.extractOptsAndCallback`
- [getsetdeep](https://github.com/bevry/getsetdeep) < `balUtilFlow.(get|set)Deep`
- [safecallback](https://github.com/bevry/safecallback) < `balUtilFlow.safeCallback`
- [safefs](https://github.com/bevry/safefs) < `balUtilPaths.(openFile|closeFile|etc)`
- [safeps](https://github.com/bevry/safeps) < `balUtilModules`
- [taskgroup](https://github.com/bevry/taskgroup) < `balUtilFlow.Group`
- [typechecker](https://github.com/bevry/typechecker) < `balUtilTypes`


<!-- CONTRIBUTE/ -->

## Contribute

[Discover how you can contribute by heading on over to the `Contributing.md` file.](https://github.com/balupton/bal-util/blob/master/Contributing.md#files)

<!-- /CONTRIBUTE -->


<!-- HISTORY/ -->

## History
[Discover the change history by heading on over to the `History.md` file.](https://github.com/balupton/bal-util/blob/master/History.md#files)

<!-- /HISTORY -->


<!-- BACKERS/ -->

## Backers

### Maintainers

These amazing people are maintaining this project:

- Benjamin Lupton <b@lupton.cc> (https://github.com/balupton)

### Sponsors

No sponsors yet! Will you be the first?

[![Gittip donate button](http://img.shields.io/gittip/balupton.png)](https://www.gittip.com/balupton/ "Donate weekly to this project using Gittip")
[![Flattr donate button](http://img.shields.io/flattr/donate.png?color=yellow)](http://flattr.com/thing/344188/balupton-on-Flattr "Donate monthly to this project using Flattr")
[![PayPayl donate button](http://img.shields.io/paypal/donate.png?color=yellow)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=QB8GQPZAH84N6 "Donate once-off to this project using Paypal")

### Contributors

These amazing people have contributed code to this project:

- Benjamin Lupton <b@lupton.cc> (https://github.com/balupton) - [view contributions](https://github.com/balupton/bal-util/commits?author=balupton)
- Sean Fridman <fridman@mail.sfsu.edu> (https://github.com/sfrdmn) - [view contributions](https://github.com/balupton/bal-util/commits?author=sfrdmn)

[Become a contributor!](https://github.com/balupton/bal-util/blob/master/Contributing.md#files)

<!-- /BACKERS -->


<!-- LICENSE/ -->

## License

Licensed under the incredibly [permissive](http://en.wikipedia.org/wiki/Permissive_free_software_licence) [MIT license](http://creativecommons.org/licenses/MIT/)

Copyright &copy; Benjamin Lupton <b@lupton.cc> (http://balupton.com)

<!-- /LICENSE -->


